require 'fluxx/resource'

# Fluxx lightweight API wrapper
module Fluxx
  # Core Fluxx API resource mappings.
  CORE_MODELS = {
    GrantRequest: 'grant_request',
    RequestReport: 'request_report',
    RequestOrganization: 'request_organization',
    RequestUser: 'request_user',
    RequestTransaction: 'request_transaction',
    Organization: 'organization',
    Program: 'program',
    SubProgram: 'sub_program',
    ModelDocument: 'model_document',
    User: 'user',
    GeoCountry: 'geo_country',
    GeoState: 'geo_state'
  }

  # Helper to define the mapped models
  #
  # @return [Class]
  def self.define_model(model_name, api_path)
    new_resource = Class.new(Resource)
    new_resource.path("/api/rest/v2/#{api_path}")
    const_set(model_name, new_resource)
  end

  CORE_MODELS.each { |k, v| define_model(k, v) }
end
